## openvpn 2.6.15

=== doc/CMakeLists.txt ===
set(_GENERATE_HTML_DOC YES)
set(_GENERATE_MAN_DOC  YES)
set(_MAYBE_PYTHON "")
find_program(RST2HTML NAMES rst2html rst2html.py)
find_program(RST2MAN  NAMES rst2man  rst2man.py)

if (RST2HTML STREQUAL "RST2HTML-NOTFOUND")
    message(STATUS "rst2html not found, not generating HTML documentation")
    set(_GENERATE_HTML_DOC NO)
else ()
    # We only run this for RST2HTML and assume the result would be the same
    # for RST2MAN
    if (DEFINED CACHE{DOCUTILS_NEED_PYTHON})
        if ($CACHE{DOCUTILS_NEED_PYTHON})
            set(_MAYBE_PYTHON ${PYTHON})
        endif ()
    else ()
        execute_process(
            COMMAND ${RST2HTML} --version
            OUTPUT_VARIABLE RST2HTML_VERSION_EXE
            )
        execute_process(
            COMMAND ${PYTHON} ${RST2HTML} --version
            OUTPUT_VARIABLE RST2HTML_VERSION_PY
            )
        set(_DOCUTILS_NEED_PYTHON OFF)
        if(RST2HTML_VERSION_EXE STREQUAL "")
            if(RST2HTML_VERSION_PY STREQUAL "")
                message(STATUS "${RST2HTML} found but not working, not generating documentation")
                set(_GENERATE_HTML_DOC NO)
                set(_GENERATE_MAN_DOC NO)
            else ()
                message(STATUS "${RST2HTML} needs to be executed by ${PYTHON} to work")
                set(_MAYBE_PYTHON ${PYTHON})
                set(_DOCUTILS_NEED_PYTHON ON)
            endif ()
        endif ()
        set(DOCUTILS_NEED_PYTHON ${_DOCUTILS_NEED_PYTHON} CACHE BOOL
            "Whether we need to call python instead of rst2*.py directly")
    endif (DEFINED CACHE{DOCUTILS_NEED_PYTHON})
endif ()
if (RST2MAN STREQUAL "RST2MAN-NOTFOUND")
    message(STATUS "rst2man not found, not generating man pages")
    set(_GENERATE_MAN_DOC NO)
endif ()

set(OPENVPN_SECTIONS
    man-sections/advanced-options.rst
    man-sections/cipher-negotiation.rst
    man-sections/client-options.rst
    man-sections/connection-profiles.rst
    man-sections/encryption-options.rst
    man-sections/generic-options.rst
    man-sections/inline-files.rst
    man-sections/link-options.rst
    man-sections/log-options.rst
    man-sections/management-options.rst
    man-sections/network-config.rst
    man-sections/pkcs11-options.rst
    man-sections/plugin-options.rst
    man-sections/protocol-options.rst
    man-sections/proxy-options.rst
    man-sections/renegotiation.rst
    man-sections/signals.rst
    man-sections/script-options.rst
    man-sections/server-options.rst
    man-sections/tls-options.rst
    man-sections/unsupported-options.rst
    man-sections/virtual-routing-and-forwarding.rst
    man-sections/vpn-network-options.rst
    man-sections/windows-options.rst
    )

set(OPENVPN_EXAMPLES_SECTIONS
    man-sections/example-fingerprint.rst
    man-sections/examples.rst
    )

set(RST_FLAGS --strict)

if (_GENERATE_HTML_DOC)
    list(APPEND ALL_DOCS openvpn.8.html openvpn-examples.5.html)
    add_custom_command(
        OUTPUT openvpn.8.html
        COMMAND ${_MAYBE_PYTHON} ${RST2HTML} ${RST_FLAGS} ${CMAKE_CURRENT_SOURCE_DIR}/openvpn.8.rst ${CMAKE_CURRENT_BINARY_DIR}/openvpn.8.html
        MAIN_DEPENDENCY openvpn.8.rst
        DEPENDS ${OPENVPN_SECTIONS}
        )
    add_custom_command(
        OUTPUT openvpn-examples.5.html
        COMMAND ${_MAYBE_PYTHON} ${RST2HTML} ${RST_FLAGS} ${CMAKE_CURRENT_SOURCE_DIR}/openvpn-examples.5.rst ${CMAKE_CURRENT_BINARY_DIR}/openvpn-examples.5.html
        MAIN_DEPENDENCY openvpn-examples.5.rst
        DEPENDS ${OPENVPN_EXAMPLES_SECTIONS}
        )
endif ()
if (_GENERATE_MAN_DOC)
    list(APPEND ALL_DOCS openvpn.8 openvpn-examples.5)
    add_custom_command(
        OUTPUT openvpn.8
        COMMAND ${_MAYBE_PYTHON} ${RST2MAN} ${RST_FLAGS} ${CMAKE_CURRENT_SOURCE_DIR}/openvpn.8.rst ${CMAKE_CURRENT_BINARY_DIR}/openvpn.8
        MAIN_DEPENDENCY openvpn.8.rst
        DEPENDS ${OPENVPN_SECTIONS}
        )
    add_custom_command(
        OUTPUT openvpn-examples.5
        COMMAND ${_MAYBE_PYTHON} ${RST2MAN} ${RST_FLAGS} ${CMAKE_CURRENT_SOURCE_DIR}/openvpn-examples.5.rst ${CMAKE_CURRENT_BINARY_DIR}/openvpn-examples.5
        MAIN_DEPENDENCY openvpn-examples.5.rst
        DEPENDS ${OPENVPN_EXAMPLES_SECTIONS}
        )
endif ()

add_custom_target(documentation ALL DEPENDS ${ALL_DOCS})

=== sample/sample-plugins/Makefile ===
# Makefile.in generated by automake 1.16.5 from Makefile.am.
# sample/sample-plugins/Makefile.  Generated from Makefile.in by configure.

# Copyright (C) 1994-2021 Free Software Foundation, Inc.

# This Makefile.in is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.



#
#  OpenVPN -- An application to securely tunnel IP networks
#             over a single UDP port, with support for SSL/TLS-based
#             session authentication and key exchange,
#             packet encryption, packet authentication, and
#             packet compression.
#
#  Copyright (C) 2002-2024 OpenVPN Inc <sales@openvpn.net>
#

#  SPDX-License-Identifier: GPL-2.0-only
#
#  Copyright (C) 2020-2024 OpenVPN Inc <sales@openvpn.net>
#

am__is_gnu_make = { \
  if test -z '$(MAKELEVEL)'; then \
    false; \
  elif test -n '$(MAKE_HOST)'; then \
    true; \
  elif test -n '$(MAKE_VERSION)' && test -n '$(CURDIR)'; then \
    true; \
  else \
    false; \
  fi; \
}
am__make_running_with_option = \
  case $${target_option-} in \
      ?) ;; \
      *) echo "am__make_running_with_option: internal error: invalid" \
              "target option '$${target_option-}' specified" >&2; \
         exit 1;; \
  esac; \
  has_opt=no; \
  sane_makeflags=$$MAKEFLAGS; \
  if $(am__is_gnu_make); then \
    sane_makeflags=$$MFLAGS; \
  else \
    case $$MAKEFLAGS in \
      *\\[\ \	]*) \
        bs=\\; \
        sane_makeflags=`printf '%s\n' "$$MAKEFLAGS" \
          | sed "s/$$bs$$bs[$$bs $$bs	]*//g"`;; \
    esac; \
  fi; \
  skip_next=no; \
  strip_trailopt () \
  { \
    flg=`printf '%s\n' "$$flg" | sed "s/$$1.*$$//"`; \
  }; \
  for flg in $$sane_makeflags; do \
    test $$skip_next = yes && { skip_next=no; continue; }; \
    case $$flg in \
      *=*|--*) continue;; \
        -*I) strip_trailopt 'I'; skip_next=yes;; \
      -*I?*) strip_trailopt 'I';; \
        -*O) strip_trailopt 'O'; skip_next=yes;; \
      -*O?*) strip_trailopt 'O';; \
        -*l) strip_trailopt 'l'; skip_next=yes;; \
      -*l?*) strip_trailopt 'l';; \
      -[dEDm]) skip_next=yes;; \
      -[JT]) skip_next=yes;; \
    esac; \
    case $$flg in \
      *$$target_option*) has_opt=yes; break;; \
    esac; \
  done; \
  test $$has_opt = yes
am__make_dryrun = (target_option=n; $(am__make_running_with_option))
am__make_keepgoing = (target_option=k; $(am__make_running_with_option))
pkgdatadir = $(datadir)/openvpn
pkgincludedir = $(includedir)/openvpn
pkglibdir = $(libdir)/openvpn
pkglibexecdir = $(libexecdir)/openvpn
am__cd = CDPATH="$${ZSH_VERSION+.}$(PATH_SEPARATOR)" && cd
install_sh_DATA = $(install_sh) -c -m 644
install_sh_PROGRAM = $(install_sh) -c
install_sh_SCRIPT = $(install_sh) -c
INSTALL_HEADER = $(INSTALL_DATA)
transform = $(program_transform_name)
NORMAL_INSTALL = :
PRE_INSTALL = :
POST_INSTALL = :
NORMAL_UNINSTALL = :
PRE_UNINSTALL = :
POST_UNINSTALL = :
build_triplet = x86_64-pc-linux-gnu
host_triplet = x86_64-pc-linux-gnu
subdir = sample/sample-plugins
ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
am__aclocal_m4_deps = $(top_srcdir)/m4/ax_socklen_t.m4 \
	$(top_srcdir)/m4/libtool.m4 $(top_srcdir)/m4/ltoptions.m4 \
	$(top_srcdir)/m4/ltsugar.m4 $(top_srcdir)/m4/ltversion.m4 \
	$(top_srcdir)/m4/lt~obsolete.m4 $(top_srcdir)/m4/pkg.m4 \
	$(top_srcdir)/version.m4 $(top_srcdir)/compat.m4 \
	$(top_srcdir)/configure.ac
am__configure_deps = $(am__aclocal_m4_deps) $(CONFIGURE_DEPENDENCIES) \
	$(ACLOCAL_M4)
DIST_COMMON = $(srcdir)/Makefile.am $(am__DIST_COMMON)
mkinstalldirs = $(install_sh) -d
CONFIG_HEADER = $(top_builddir)/config.h \
	$(top_builddir)/include/openvpn-plugin.h
CONFIG_CLEAN_FILES =
CONFIG_CLEAN_VPATH_FILES =
AM_V_P = $(am__v_P_$(V))
am__v_P_ = $(am__v_P_$(AM_DEFAULT_VERBOSITY))
am__v_P_0 = false
am__v_P_1 = :
AM_V_GEN = $(am__v_GEN_$(V))
am__v_GEN_ = $(am__v_GEN_$(AM_DEFAULT_VERBOSITY))
am__v_GEN_0 = @echo "  GEN     " $@;
am__v_GEN_1 = 
AM_V_at = $(am__v_at_$(V))
am__v_at_ = $(am__v_at_$(AM_DEFAULT_VERBOSITY))
am__v_at_0 = @
am__v_at_1 = 
SOURCES =
DIST_SOURCES =
am__can_run_installinfo = \
  case $$AM_UPDATE_INFO_DIR in \
    n|no|NO) false;; \
    *) (install-info --version) >/dev/null 2>&1;; \
  esac
am__tagged_files = $(HEADERS) $(SOURCES) $(TAGS_FILES) $(LISP)
am__DIST_COMMON = $(srcdir)/Makefile.in $(srcdir)/Makefile.plugins \
	README
DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
ACLOCAL = ${SHELL} '/home/flichtenheld/openvpn/community/openvpn-build/src/openvpn/missing' aclocal-1.16
AMTAR = $${TAR-tar}
AM_DEFAULT_VERBOSITY = 1
AR = ar
AS = as
AUTOCONF = ${SHELL} '/home/flichtenheld/openvpn/community/openvpn-build/src/openvpn/missing' autoconf
AUTOHEADER = ${SHELL} '/home/flichtenheld/openvpn/community/openvpn-build/src/openvpn/missing' autoheader
AUTOMAKE = ${SHELL} '/home/flichtenheld/openvpn/community/openvpn-build/src/openvpn/missing' automake-1.16
AWK = gawk
CC = gcc
CCDEPMODE = depmode=gcc3
CFLAGS = -Wall -Wno-stringop-truncation -g -O2 -std=c99 
CMOCKA_CFLAGS = 
CMOCKA_LIBS = -lcmocka
CPP = gcc -E
CPPFLAGS = 
CSCOPE = cscope
CTAGS = ctags
CYGPATH_W = echo
DEFS = -DHAVE_CONFIG_H
DEPDIR = .deps
DLLTOOL = false
DL_LIBS = -ldl
DSYMUTIL = 
DUMPBIN = 
ECHO_C = 
ECHO_N = -n
ECHO_T = 
EGREP = /usr/bin/grep -E
ENABLE_UNITTESTS = 
ETAGS = etags
EXEEXT = 
FGREP = /usr/bin/grep -F
GIT = git
GREP = /usr/bin/grep
IFCONFIG = /usr/sbin/ifconfig
INSTALL = /usr/bin/install -c
INSTALL_DATA = ${INSTALL} -m 644
INSTALL_PROGRAM = ${INSTALL}
INSTALL_SCRIPT = ${INSTALL}
INSTALL_STRIP_PROGRAM = $(install_sh) -c -s
IPROUTE = /usr/sbin/ip
LD = /usr/bin/ld -m elf_x86_64
LDFLAGS = 
LIBCAPNG_CFLAGS = 
LIBCAPNG_LIBS = -lcap-ng
LIBNL_GENL_CFLAGS = 
LIBNL_GENL_LIBS = 
LIBOBJS = 
LIBPAM_CFLAGS = 
LIBPAM_LIBS = -lpam
LIBS =  -lcap-ng
LIBTOOL = $(SHELL) $(top_builddir)/libtool
LIPO = 
LN_S = ln -s
LTLIBOBJS = 
LT_SYS_LIBRARY_PATH = 
LZ4_CFLAGS = 
LZ4_LIBS = 
LZO_CFLAGS = -I/usr/lzo/lzo
LZO_LIBS = -llzo2
MAKEINFO = ${SHELL} '/home/flichtenheld/openvpn/community/openvpn-build/src/openvpn/missing' makeinfo
MANIFEST_TOOL = :
MBEDTLS_CFLAGS = 
MBEDTLS_LIBS = 
MKDIR_P = /usr/bin/mkdir -p
NETSTAT = netstat
NM = /usr/bin/nm -B
NMEDIT = 
OBJDUMP = objdump
OBJEXT = o
OPENSSL_CFLAGS = 
OPENSSL_LIBS = -lssl -lcrypto
OPENVPN_VERSION_MAJOR = 2
OPENVPN_VERSION_MINOR = 6
OPENVPN_VERSION_PATCH = .15
OPTIONAL_CRYPTO_CFLAGS =  
OPTIONAL_CRYPTO_LIBS =  -lssl -lcrypto
OPTIONAL_DL_LIBS = -ldl
OPTIONAL_INOTIFY_CFLAGS = 
OPTIONAL_INOTIFY_LIBS = 
OPTIONAL_LZ4_CFLAGS = 
OPTIONAL_LZ4_LIBS = 
OPTIONAL_LZO_CFLAGS = 
OPTIONAL_LZO_LIBS = 
OPTIONAL_PKCS11_HELPER_CFLAGS = 
OPTIONAL_PKCS11_HELPER_LIBS = 
OPTIONAL_SELINUX_LIBS = 
OPTIONAL_SYSTEMD_LIBS = 
OTOOL = 
OTOOL64 = 
P11KIT_CFLAGS = 
P11KIT_LIBS = 
PACKAGE = openvpn
PACKAGE_BUGREPORT = openvpn-users@lists.sourceforge.net
PACKAGE_NAME = OpenVPN
PACKAGE_STRING = OpenVPN 2.6.15
PACKAGE_TARNAME = openvpn
PACKAGE_URL = 
PACKAGE_VERSION = 2.6.15
PATH_SEPARATOR = :
PKCS11_HELPER_CFLAGS = 
PKCS11_HELPER_LIBS = -lpthread -ldl -lcrypto -lpkcs11-helper
PKG_CONFIG = /usr/bin/pkg-config
PKG_CONFIG_LIBDIR = 
PKG_CONFIG_PATH = 
PLUGINDIR = 
PLUGIN_AUTH_PAM_CFLAGS = 
PLUGIN_AUTH_PAM_LIBS = 
RANLIB = ranlib
RC = 
ROUTE = /usr/sbin/route
RST2HTML = rst2html
RST2MAN = rst2man
SED = /usr/bin/sed
SELINUX_LIBS = -lselinux
SET_MAKE = 
SHELL = /bin/bash
SOCKETS_LIBS =  -lnsl -lresolv
STRIP = strip
SYSTEMD_ASK_PASSWORD = /usr/bin/systemd-ask-password
SYSTEMD_UNIT_DIR = 
TAP_CFLAGS = 
TAP_WIN_COMPONENT_ID = tap0901
TAP_WIN_MIN_MAJOR = 9
TAP_WIN_MIN_MINOR = 9
TEST_CFLAGS =     -I$(top_srcdir)/include 
TEST_LDFLAGS =  -lssl -lcrypto   -lcmocka
TMPFILES_DIR = 
VERSION = 2.6.15
WINDMC = no
WOLFSSL_CFLAGS = 
WOLFSSL_INCLUDEDIR = 
WOLFSSL_LIBS = 
abs_builddir = /home/flichtenheld/openvpn/community/openvpn-build/src/openvpn/sample/sample-plugins
abs_srcdir = /home/flichtenheld/openvpn/community/openvpn-build/src/openvpn/sample/sample-plugins
abs_top_builddir = /home/flichtenheld/openvpn/community/openvpn-build/src/openvpn
abs_top_srcdir = /home/flichtenheld/openvpn/community/openvpn-build/src/openvpn
ac_ct_AR = ar
ac_ct_CC = gcc
ac_ct_DUMPBIN = 
ac_ct_WINDMC = 
am__include = include
am__leading_dot = .
am__quote = 
am__tar = $${TAR-tar} chof - "$$tardir"
am__untar = $${TAR-tar} xf -
bindir = ${exec_prefix}/bin
build = x86_64-pc-linux-gnu
build_alias = 
build_cpu = x86_64
build_os = linux-gnu
build_vendor = pc
builddir = .
datadir = ${datarootdir}
datarootdir = ${prefix}/share
docdir = ${datarootdir}/doc/${PACKAGE_TARNAME}
dvidir = ${docdir}
exec_prefix = ${prefix}
host = x86_64-pc-linux-gnu
host_alias = 
host_cpu = x86_64
host_os = linux-gnu
host_vendor = pc
htmldir = ${docdir}
includedir = ${prefix}/include
infodir = ${datarootdir}/info
install_sh = ${SHELL} /home/flichtenheld/openvpn/community/openvpn-build/src/openvpn/install-sh
libdir = ${exec_prefix}/lib
libexecdir = ${exec_prefix}/libexec
libsystemd_CFLAGS = 
libsystemd_LIBS = 
localedir = ${datarootdir}/locale
localstatedir = ${prefix}/var
mandir = ${datarootdir}/man
mkdir_p = $(MKDIR_P)
oldincludedir = /usr/include
pdfdir = ${docdir}
plugindir = ${libdir}/openvpn/plugins
prefix = /usr/local
program_transform_name = s,x,x,
psdir = ${docdir}
runstatedir = ${localstatedir}/run
sampledir = $(docdir)/sample
sbindir = ${exec_prefix}/sbin
sharedstatedir = ${prefix}/com
srcdir = .
sysconfdir = ${prefix}/etc
systemdunitdir = 
target_alias = 
tmpfilesdir = 
top_build_prefix = ../../
top_builddir = ../..
top_srcdir = ../..
MAINTAINERCLEANFILES = \
	$(srcdir)/Makefile.in

AM_CPPFLAGS = -I$(top_srcdir) -I$(top_builddir) \
	-I$(top_srcdir)/include -I$(top_builddir)/include


#
# Plug-ins to build - listed entries should not carry any extensions
#
PLUGINS = \
	defer/multi-auth \
	keying-material-exporter-demo/keyingmaterialexporter \
	log/log log/log_v3 \
	simple/base64 \
	simple/simple \
	client-connect/sample-client-connect

all: all-am

.SUFFIXES:
.SUFFIXES: .c .o
$(srcdir)/Makefile.in:  $(srcdir)/Makefile.am $(srcdir)/Makefile.plugins $(am__configure_deps)
	@for dep in $?; do \
	  case '$(am__configure_deps)' in \
	    *$$dep*) \
	      ( cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh ) \
	        && { if test -f $@; then exit 0; else break; fi; }; \
	      exit 1;; \
	  esac; \
	done; \
	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign sample/sample-plugins/Makefile'; \
	$(am__cd) $(top_srcdir) && \
	  $(AUTOMAKE) --foreign sample/sample-plugins/Makefile
Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
	@case '$?' in \
	  *config.status*) \
	    cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh;; \
	  *) \
	    echo ' cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__maybe_remake_depfiles)'; \
	    cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__maybe_remake_depfiles);; \
	esac;
$(srcdir)/Makefile.plugins $(am__empty):

$(top_builddir)/config.status: $(top_srcdir)/configure $(CONFIG_STATUS_DEPENDENCIES)
	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh

$(top_srcdir)/configure:  $(am__configure_deps)
	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
$(ACLOCAL_M4):  $(am__aclocal_m4_deps)
	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
$(am__aclocal_m4_deps):

mostlyclean-libtool:
	-rm -f *.lo

clean-libtool:
	-rm -rf .libs _libs
tags TAGS:

ctags CTAGS:

cscope cscopelist:

distdir: $(BUILT_SOURCES)
	$(MAKE) $(AM_MAKEFLAGS) distdir-am

distdir-am: $(DISTFILES)
	@srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
	topsrcdirstrip=`echo "$(top_srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
	list='$(DISTFILES)'; \
	  dist_files=`for file in $$list; do echo $$file; done | \
	  sed -e "s|^$$srcdirstrip/||;t" \

=== src/openvpnmsica/CMakeLists.txt ===
if (NOT WIN32)
    return ()
endif ()

project(openvpnmsica)

add_library(openvpnmsica SHARED)

target_include_directories(openvpnmsica PRIVATE
    ${CMAKE_CURRENT_BINARY_DIR}/../../
    ../../include/
    ../compat/
    )
target_sources(openvpnmsica PRIVATE
    dllmain.c
    msiex.c msiex.h
    msica_arg.c msica_arg.h
    openvpnmsica.c openvpnmsica.h
    ../tapctl/basic.h
    ../tapctl/error.c ../tapctl/error.h
    ../tapctl/tap.c ../tapctl/tap.h
    openvpnmsica_resources.rc
    )
target_compile_options(openvpnmsica PRIVATE
    -D_UNICODE
    -UNTDDI_VERSION
    -D_WIN32_WINNT=_WIN32_WINNT_VISTA
    )

if (MSVC)
    target_compile_options(openvpnmsica PRIVATE
        "$<$<CONFIG:Release>:/MT>"
        "$<$<CONFIG:Debug>:/MTd>"
        )
endif ()

target_link_libraries(openvpnmsica
    advapi32.lib ole32.lib msi.lib setupapi.lib iphlpapi.lib shell32.lib shlwapi.lib version.lib newdev.lib)
if (MINGW)
    target_compile_options(openvpnmsica PRIVATE -municode)
    target_link_options(openvpnmsica PRIVATE -municode)
    target_link_options(openvpnmsica PRIVATE
        -Wl,--kill-at)
endif ()

=== src/tapctl/CMakeLists.txt ===
if (NOT WIN32)
    return ()
endif ()

project(tapctl)

add_executable(tapctl)

target_include_directories(tapctl PRIVATE
    ${CMAKE_CURRENT_BINARY_DIR}/../../
    ../../include/
    ../compat/
    )
target_sources(tapctl PRIVATE
    basic.h
    error.c error.h
    main.c
    tap.c tap.h
    tapctl_resources.rc
    )
target_compile_options(tapctl PRIVATE
    -D_UNICODE
    -UNTDDI_VERSION
    -D_WIN32_WINNT=_WIN32_WINNT_VISTA
    )
target_link_libraries(tapctl
    advapi32.lib ole32.lib setupapi.lib)
if (MINGW)
    target_compile_options(tapctl PRIVATE -municode)
    target_link_options(tapctl PRIVATE -municode)
endif ()

=== debian/changelog ===
openvpn (2.6.15-1ubuntu1) resolute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/control: Demote easy-rsa to Suggests (universe package).
    - debian/openvpn@.service: Add '--script-security 2' similar to what
      got added to debian/openvpn.init.d ages ago (LP #1454725)
    - d/t/control: Move to isolation-container to enable armhf/LXD coverage.
      (LP #2104146)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 Oct 2025 18:54:34 +0100

openvpn (2.6.15-1) unstable; urgency=medium

  * New upstream version 2.6.15 (Closes: #1118074)
    - Drop Kernel 6.16+ fix applied upstream

 -- Bernhard Schmidt <berni@debian.org>  Sun, 26 Oct 2025 16:32:43 +0100

openvpn (2.6.14-2ubuntu1) questing; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/control: Demote easy-rsa to Suggests (universe package).
    - debian/openvpn@.service: Add '--script-security 2' similar to what
      got added to debian/openvpn.init.d ages ago (LP #1454725)
    - d/t/control: Move to isolation-container to enable armhf/LXD coverage.
      (LP #2104146)
    - d/p/handle_intentional_route_push_float_ip.patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 06 Sep 2025 08:40:39 +0200

openvpn (2.6.14-1ubuntu2) questing; urgency=medium

  * d/p/handle_intentional_route_push_float_ip.patch: Fix floating IP due
    to "route VPN_IP net_gateway", which can lead to incorrect blocking of
    a source IP switch for 60 seconds immediately after connection setup.
    (LP: #2108860)

 -- Bryce Harrington <bryce@canonical.com>  Thu, 28 Aug 2025 15:34:24 -0700

openvpn (2.6.14-1ubuntu1) questing; urgency=medium

  * Merge from Debian Unstable (LP: #2110417). Remaining changes:
    - d/control: Demote easy-rsa to Suggests (universe package).
    - debian/openvpn@.service: Add '--script-security 2' similar to what
      got added to debian/openvpn.init.d ages ago (LP #1454725)
    - d/t/control: Move to isolation-container to enable armhf/LXD coverage.
      (LP #2104146)
  * Dropped Changes:
    - SECURITY UPDATE: denial of service issue
      + debian/patches/CVE-2025-2704.patch: allow tls-crypt-v2 to be setup
        only on initial packet of a session in src/openvpn/ssl.c,
        src/openvpn/ssl_common.h, src/openvpn/ssl_pkt.c,
        src/openvpn/ssl_pkt.h, src/openvpn/tls_crypt.c,
        src/openvpn/tls_crypt.h, tests/unit_tests/openvpn/test_tls_crypt.c.
      + CVE-2025-2704
      [ Fixed upstream in 2.6.14 ]

 -- Lena Voytek <lena.voytek@canonical.com>  Wed, 21 May 2025 13:13:19 -0400

=== debian/control ===
Source: openvpn
Section: net
Priority: optional
Maintainer: Bernhard Schmidt <berni@debian.org>
Uploaders: Jörg Frings-Fürst <debian@jff.email>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-dev (>= 1.16.1),
 libcap-ng-dev [linux-any],
 liblz4-dev,
 liblzo2-dev,
 libnl-genl-3-dev [linux-any],
 libp11-kit-dev,
 libpam0g-dev,
 libpkcs11-helper1-dev,
 libssl-dev,
 libsystemd-dev [linux-any],
 net-tools [!linux-any],
 pkg-config,
 python3-docutils,
 systemd-dev [linux-any]
Standards-Version: 4.6.0.1
Rules-Requires-Root: no
Homepage: https://openvpn.net/community/
Vcs-Git: https://salsa.debian.org/debian/openvpn.git
Vcs-Browser: https://salsa.debian.org/debian/openvpn

Package: openvpn
Architecture: any
Depends:
 debconf | debconf-2.0,
 ${shlibs:Depends},
 ${misc:Depends},
 net-tools [!linux-any],
Suggests:
 openssl,
 resolvconf,
 openvpn-dco-dkms,
 openvpn-systemd-resolved,
 easy-rsa
Description: virtual private network daemon
 OpenVPN is an application to securely tunnel IP networks over a
 single UDP or TCP port. It can be used to access remote sites, make
 secure point-to-point connections, enhance wireless security, etc.
 .
 OpenVPN uses all of the encryption, authentication, and certification
 features provided by the OpenSSL library (any cipher, key size, or
 HMAC digest).
 .
 OpenVPN may use static, pre-shared keys or TLS-based dynamic key exchange. It
 also supports VPNs with dynamic endpoints (DHCP or dial-up clients), tunnels
 over NAT or connection-oriented stateful firewalls (such as Linux's iptables).

=== debian/tests/control ===
Tests: server-setup-with-ca
Depends: openvpn, easy-rsa
Restrictions: needs-root, isolation-container, allow-stderr

Tests: server-setup-with-static-key
Restrictions: needs-root, isolation-container, allow-stderr

Tests: unit-tests
Depends: libcmocka-dev, @builddeps@
Restrictions: allow-stderr

## openvpn 2.6.19

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
set(CMAKE_CONFIGURATION_TYPES "Release;Debug;ASAN")
project(openvpn)

# This CMake file implements building OpenVPN with CMAKE
#
# Note that this is *NOT* the official way to build openvpn on anything
# other than Windows/mingw despite working on other platforms too. You will need
# to add -DUNSUPPORTED_BUILDS=true to build on non Windows platforms.
#
# This cmake also makes a few assertions like lzo, lz4 being used
# and OpenSSL having version 1.1.1+ and generally does not offer the same
# configurability like autoconf

find_package(PkgConfig REQUIRED)
include(CheckSymbolExists)
include(CheckIncludeFiles)
include(CheckCCompilerFlag)
include(CheckLinkerFlag OPTIONAL)
include(CheckTypeSize)
include(CheckStructHasMember)
include(CTest)

option(UNSUPPORTED_BUILDS "Allow unsupported builds" OFF)

if (NOT WIN32 AND NOT ${UNSUPPORTED_BUILDS})
    message(FATAL_ERROR "Note: on Unix platform the official and supported build method is using autoconfig. CMake based build should be only used for Windows and internal testing/development.")
endif()

if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/config.h")
    message(FATAL_ERROR "The top level source directory has a config.h file. Note that you can't mix in-tree autoconfig builds with out-of-tree cmake builds.")
endif ()

option(MBED "BUILD with mbed" OFF)
option(WOLFSSL "BUILD with wolfSSL" OFF)
option(ENABLE_LZ4 "BUILD with lz4" ON)
option(ENABLE_LZO "BUILD with lzo" ON)
option(ENABLE_PKCS11 "BUILD with pkcs11-helper" ON)
option(USE_WERROR "Treat compiler warnings as errors (-Werror)" ON)

set(PLUGIN_DIR /usr/local/lib/openvpn/plugins CACHE FILEPATH "Location of the plugin directory")

# AddressSanitize - use CXX=clang++ CC=clang cmake -DCMAKE_BUILD_TYPE=asan to build with ASAN
set(CMAKE_C_FLAGS_ASAN
    "-fsanitize=address,undefined -fno-sanitize-recover=all -fno-optimize-sibling-calls -fsanitize-address-use-after-scope -fno-omit-frame-pointer -g -O1"
    CACHE STRING "Flags used by the C compiler during AddressSanitizer builds."
    FORCE)
set(CMAKE_CXX_FLAGS_ASAN
    "-fsanitize=address,undefined -fno-sanitize-recover=all -fno-optimize-sibling-calls -fsanitize-address-use-after-scope -fno-omit-frame-pointer -g -O1"
    CACHE STRING "Flags used by the C++ compiler during AddressSanitizer builds."
    FORCE)

if (MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_CRT_NONSTDC_NO_DEPRECATE -D_WINSOCK_DEPRECATED_NO_WARNINGS)
    if (USE_WERROR)
        add_compile_options(/WX)
    endif ()
    add_compile_options(
        /MP
        /W2
        /sdl
        /Qspectre
        /guard:cf
        /FC
        /ZH:SHA_256
        "$<$<CONFIG:Release>:/GL>"
        "$<$<CONFIG:Release>:/Oi>"
        "$<$<CONFIG:Release>:/Gy>"
        "$<$<CONFIG:Release>:/Zi>"
        )
    add_link_options(
        /Brepro
        "$<$<CONFIG:Release>:/LTCG:incremental>"
        "$<$<CONFIG:Release>:/DEBUG:FULL>"
        "$<$<CONFIG:Release>:/OPT:REF>"
        "$<$<CONFIG:Release>:/OPT:ICF>"
        )
    if (${CMAKE_GENERATOR_PLATFORM} STREQUAL "x64" OR ${CMAKE_GENERATOR_PLATFORM} STREQUAL "x86")
        add_link_options("$<$<CONFIG:Release>:/CETCOMPAT>")
    endif()
else ()
    set(CMAKE_C_FLAGS_RELEASE "-O2")
    set(CMAKE_CXX_FLAGS_RELEASE "-O2")
    set(CMAKE_C_FLAGS_DEBUG "-g -O1")
    set(CMAKE_CXX_FLAGS_DEBUG "-g -O1")
    add_compile_options(-Wall -Wuninitialized)
    check_c_compiler_flag(-Wno-stringop-truncation NoStringOpTruncation)

    if (${NoStringOpTruncation})
        add_compile_options(-Wno-stringop-truncation)
    endif()
    # We are not ready for this
    #add_compile_options(-Wconversion -Wno-sign-conversion -Wsign-compare)
    if (USE_WERROR)
        add_compile_options(-Werror)
    endif ()
endif ()

find_program(PYTHON NAMES python3 python)
execute_process(
    COMMAND ${PYTHON} ${CMAKE_CURRENT_SOURCE_DIR}/contrib/cmake/parse-version.m4.py ${CMAKE_CURRENT_SOURCE_DIR}/version.m4
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    )
include(${CMAKE_CURRENT_BINARY_DIR}/version.cmake)

set(OPENVPN_VERSION_MAJOR ${PRODUCT_VERSION_MAJOR})
set(OPENVPN_VERSION_MINOR ${PRODUCT_VERSION_MINOR})
set(OPENVPN_VERSION_PATCH ${PRODUCT_VERSION_PATCH})
set(OPENVPN_VERSION_RESOURCE ${PRODUCT_VERSION_RESOURCE})

set(CMAKE_C_STANDARD 99)

# Set the various defines for config.h.cmake.in
if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    set(TARGET_LINUX YES)
    set(ENABLE_ASYNC_PUSH YES)
    set(ENABLE_LINUXDCO YES)
    set(ENABLE_SITNL YES)
    set(HAVE_DECL_SO_MARK YES)
    set(ENABLE_FEATURE_TUN_PERSIST 1)
    set(HAVE_LINUX_TYPES_H 1)
    set(ENABLE_DCO YES)
    set(HAVE_CMSGHDR YES)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
    set(TARGET_FREEBSD YES)
    set(ENABLE_DCO YES)
    link_libraries(-lnv)
elseif (WIN32)
    set(ENABLE_DCO YES)
elseif (APPLE)
    set(TARGET_DARWIN YES)
    set(HAVE_NET_IF_UTUN_H YES)
endif ()

if (UNIX)
    set(PATH_SEPARATOR /)
    set(ENABLE_PORT_SHARE YES)
    set(HAVE_SA_FAMILY_T YES)
elseif (WIN32)
    set(PATH_SEPARATOR \\\\)
    set(TARGET_WIN32 YES)
endif ()

check_symbol_exists(chroot unistd.h HAVE_CHROOT)
check_symbol_exists(chdir unistd.h HAVE_CHDIR)
check_symbol_exists(dup unistd.h HAVE_DUP)
check_symbol_exists(dup2 unistd.h HAVE_DUP2)
check_symbol_exists(fork unistd.h HAVE_FORK)
check_symbol_exists(execve unistd.h HAVE_EXECVE)
check_symbol_exists(ftruncate unistd.h HAVE_FTRUNCATE)
check_symbol_exists(nice unistd.h HAVE_NICE)
check_symbol_exists(setgid unistd.h HAVE_SETGID)
check_symbol_exists(setuid unistd.h HAVE_SETUID)
check_symbol_exists(setsid unistd.h HAVE_SETSID)
check_symbol_exists(getpeereid unistd.h HAVE_GETPEEREID)

check_symbol_exists(epoll_create sys/epoll.h HAVE_EPOLL_CREATE)

check_symbol_exists(gettimeofday sys/time.h HAVE_GETTIMEOFDAY)
check_symbol_exists(basename libgen.h HAVE_BASENAME)
check_symbol_exists(chsize io.h HAVE_CHSIZE)
check_symbol_exists(daemon "unistd.h;stdlib.h" HAVE_DAEMON)
check_symbol_exists(dirname libgen.h HAVE_DIRNAME)
check_symbol_exists(getrlimit sys/resource.h HAVE_GETRLIMIT)
check_symbol_exists(mlockall sys/mman.h HAVE_MLOCKALL)

check_symbol_exists(sendmsg sys/socket.h HAVE_SENDMSG)
check_symbol_exists(recvmsg sys/socket.h HAVE_RECVMSG)
check_symbol_exists(cmsghdr sys/socket.h HAVE_CMSGHDR)
check_symbol_exists(openlog syslog.h HAVE_OPENLOG)
check_symbol_exists(syslog syslog.h HAVE_SYSLOG)
check_symbol_exists(getgrnam grp.h HAVE_GETGRNAM)
check_symbol_exists(getpwnam pwd.h HAVE_GETPWNAM)
check_symbol_exists(getsockname sys/socket.h HAVE_GETSOCKNAME)

# Some OS (e.g. FreeBSD) need some basic headers to allow
# including network headers
set(NETEXTRA sys/types.h)
check_include_files("${NETEXTRA};netinet/in.h" HAVE_NETINET_IN_H)

if (HAVE_NETINET_IN_H)
    list(APPEND NETEXTRA netinet/in.h)
endif ()

check_include_files("${NETEXTRA};netinet/in6.h" HAVE_NETINET_IN_H)
check_include_files(linux/if_tun.h HAVE_LINUX_IF_TUN_H)
check_include_files(linux/sockios.h HAVE_LINUX_SOCKIOS_H)
check_include_files(dlfcn.h HAVE_DLFCN_H)
check_include_files(fcntl.h HAVE_FCNTL_H)
check_include_files(dmalloc.h HAVE_DMALLOC_H)
check_include_files(err.h HAVE_ERR_H)
check_include_files(sys/epoll.h HAVE_SYS_EPOLL_H)
check_include_files(poll.h HAVE_POLL_H)
check_include_files(sys/socket.h HAVE_SYS_SOCKET_H)
check_include_files(sys/time.h HAVE_SYS_TIME_H)
check_include_files(netdb.h HAVE_NETDB_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(sys/un.h HAVE_SYS_UN_H)
check_include_files(libgen.h HAVE_LIBGEN_H)
check_include_files(net/if.h HAVE_NET_IF_H)
check_include_files("${NETEXTRA};netinet/ip.h" HAVE_NETINET_IP_H)
check_include_files(arpa/inet.h HAVE_ARPA_INET_H)
check_include_files(net/if_utun.h HAVE_NET_UTUN_H)
check_include_files(sys/ioctl.h HAVE_SYS_IOCTL_H)
check_include_files(sys/inotify.h HAVE_SYS_INOTIFY_H)
check_include_files("${NETEXTRA};sys/uio.h" HAVE_SYS_UIO_H)
check_include_files(syslog.h HAVE_SYSLOG_H)
check_include_files(sys/wait.h HAVE_SYS_WAIT_H)
check_include_files(grp.h HAVE_GRP_H)
check_include_files(pwd.h HAVE_PWD_H)
check_include_files(sys/mman.h HAVE_SYS_MMAN_H)


check_include_files("${NETEXTRA};resolv.h" HAVE_RESOLV_H)
check_include_files("${NETEXTRA};net/if_tun.h" HAVE_NET_IF_TUN_H)

set(CMAKE_EXTRA_INCLUDE_FILES netinet/ip.h)
check_type_size("struct in_pktinfo" IN_PKTINFO)
check_struct_has_member("struct in_pktinfo" ipi_spec_dst netinet/ip.h HAVE_IPI_SPEC_DST)
check_type_size("struct msghdr" MSGHDR)
set(CMAKE_EXTRA_INCLUDE_FILES)

find_program(IFCONFIG_PATH ifconfig)
find_program(IPROUTE_PATH ip)
find_program(ROUTE_PATH route)

if (${ENABLE_LZ4})
    pkg_search_module(liblz4 liblz4 REQUIRED IMPORTED_TARGET)
endif ()

if (${ENABLE_LZO})
    pkg_search_module(lzo2 lzo2 REQUIRED IMPORTED_TARGET)
endif ()

if (${ENABLE_PKCS11})
    pkg_search_module(pkcs11-helper libpkcs11-helper-1 REQUIRED IMPORTED_TARGET)
endif ()

function(add_library_deps target)
    if (${MBED})
        target_link_libraries(${target} -lmbedtls -lmbedx509 -lmbedcrypto)
    elseif (${WOLFSSL})
        pkg_search_module(wolfssl wolfssl REQUIRED)
        target_link_libraries(${target} PUBLIC ${wolfssl_LINK_LIBRARIES})
        target_include_directories(${target} PRIVATE ${wolfssl_INCLUDE_DIRS}/wolfssl)
    else ()
        set(ENABLE_X509ALTUSERNAME YES)

        find_package(OpenSSL REQUIRED)
        target_link_libraries(${target} PUBLIC OpenSSL::SSL OpenSSL::Crypto)
        if (WIN32)
            target_link_libraries(${target} PUBLIC
                ws2_32.lib crypt32.lib fwpuclnt.lib iphlpapi.lib
                wininet.lib setupapi.lib rpcrt4.lib wtsapi32.lib ncrypt.lib bcrypt.lib)
        endif ()

    endif ()

    # optional dependencies
    target_link_libraries(${target} PUBLIC
        $<TARGET_NAME_IF_EXISTS:PkgConfig::liblz4>
        $<TARGET_NAME_IF_EXISTS:PkgConfig::lzo2>
        $<TARGET_NAME_IF_EXISTS:PkgConfig::pkcs11-helper>
        )

    if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
        pkg_search_module(libcapng REQUIRED libcap-ng IMPORTED_TARGET)
        pkg_search_module(libnl REQUIRED libnl-genl-3.0 IMPORTED_TARGET)

        target_link_libraries(${target} PUBLIC PkgConfig::libcapng PkgConfig::libnl)
    endif ()

endfunction()

if (${MBED})
    set(ENABLE_CRYPTO_MBEDTLS YES)
elseif (${WOLFSSL})
    set(ENABLE_CRYPTO_OPENSSL YES)
    set(ENABLE_CRYPTO_WOLFSSL YES)
    set(ENABLE_X509ALTUSERNAME YES)
else ()
    set(ENABLE_CRYPTO_OPENSSL YES)
    set(ENABLE_X509ALTUSERNAME YES)
endif ()

include_directories(${CMAKE_CURRENT_SOURCE_DIR} src/compat include)

add_custom_command(
    OUTPUT always_rebuild config-version.h
    COMMAND ${PYTHON} ${CMAKE_CURRENT_SOURCE_DIR}/contrib/cmake/git-version.py
    )
set(HAVE_CONFIG_VERSION_H YES)

if (BUILD_TESTING)
    find_package(cmocka CONFIG)
    if (TARGET cmocka::cmocka)
        set(CMOCKA_LIBRARIES cmocka::cmocka)
    else ()
        pkg_search_module(cmocka cmocka REQUIRED IMPORTED_TARGET)
        set(CMOCKA_LIBRARIES PkgConfig::cmocka)
    endif ()
    set(CMAKE_REQUIRED_LIBRARIES ${CMOCKA_LIBRARIES})
    check_include_files(cmocka_version.h HAVE_CMOCKA_VERSION_H)
endif ()

configure_file(config.h.cmake.in config.h)
configure_file(include/openvpn-plugin.h.in openvpn-plugin.h)
# TODO we should remove the need for this, and always include config.h
add_definitions(-DHAVE_CONFIG_H)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(doc)
add_subdirectory(src/openvpnmsica)
add_subdirectory(src/openvpnserv)
add_subdirectory(src/tapctl)

set(SOURCE_FILES
    ${CMAKE_CURRENT_BINARY_DIR}/config.h
    ${CMAKE_CURRENT_BINARY_DIR}/config-version.h
    ${CMAKE_CURRENT_BINARY_DIR}/openvpn-plugin.h

    src/compat/compat-basename.c
    src/compat/compat-daemon.c
    src/compat/compat-dirname.c
    src/compat/compat-gettimeofday.c
    src/compat/compat-strsep.c
    src/openvpn/argv.c
    src/openvpn/argv.h
    src/openvpn/base64.c
    src/openvpn/base64.h
    src/openvpn/basic.h
    src/openvpn/block_dns.h
    src/openvpn/block_dns.c
    src/openvpn/buffer.c

=== sample/sample-plugins/Makefile ===
--- 
+++ 
@@ -154,7 +154,7 @@
 CCDEPMODE = depmode=gcc3
 CFLAGS = -Wall -Wno-stringop-truncation -g -O2 -std=c99 
 CMOCKA_CFLAGS = 
-CMOCKA_LIBS = -lcmocka
+CMOCKA_LIBS = -lcmocka 
 CPP = gcc -E
 CPPFLAGS = 
 CSCOPE = cscope
@@ -174,6 +174,7 @@
 ETAGS = etags
 EXEEXT = 
 FGREP = /usr/bin/grep -F
+FILECMD = file
 GIT = git
 GREP = /usr/bin/grep
 IFCONFIG = /usr/sbin/ifconfig
@@ -186,13 +187,13 @@
 LD = /usr/bin/ld -m elf_x86_64
 LDFLAGS = 
 LIBCAPNG_CFLAGS = 
-LIBCAPNG_LIBS = -lcap-ng
+LIBCAPNG_LIBS = -lcap-ng 
 LIBNL_GENL_CFLAGS = 
 LIBNL_GENL_LIBS = 
 LIBOBJS = 
 LIBPAM_CFLAGS = 
 LIBPAM_LIBS = -lpam
-LIBS =  -lcap-ng
+LIBS =  -lcap-ng 
 LIBTOOL = $(SHELL) $(top_builddir)/libtool
 LIPO = 
 LN_S = ln -s
@@ -200,8 +201,8 @@
 LT_SYS_LIBRARY_PATH = 
 LZ4_CFLAGS = 
 LZ4_LIBS = 
-LZO_CFLAGS = -I/usr/lzo/lzo
-LZO_LIBS = -llzo2
+LZO_CFLAGS = -I/usr/include/lzo 
+LZO_LIBS = -llzo2 
 MAKEINFO = ${SHELL} '/home/flichtenheld/openvpn/community/openvpn-build/src/openvpn/missing' makeinfo
 MANIFEST_TOOL = :
 MBEDTLS_CFLAGS = 
@@ -213,12 +214,12 @@
 OBJDUMP = objdump
 OBJEXT = o
 OPENSSL_CFLAGS = 
-OPENSSL_LIBS = -lssl -lcrypto
+OPENSSL_LIBS = -lssl -lcrypto 
 OPENVPN_VERSION_MAJOR = 2
 OPENVPN_VERSION_MINOR = 6
-OPENVPN_VERSION_PATCH = .15
+OPENVPN_VERSION_PATCH = .19
 OPTIONAL_CRYPTO_CFLAGS =  
-OPTIONAL_CRYPTO_LIBS =  -lssl -lcrypto
+OPTIONAL_CRYPTO_LIBS =  -lssl -lcrypto 
 OPTIONAL_DL_LIBS = -ldl
 OPTIONAL_INOTIFY_CFLAGS = 
 OPTIONAL_INOTIFY_LIBS = 
@@ -237,13 +238,13 @@
 PACKAGE = openvpn
 PACKAGE_BUGREPORT = openvpn-users@lists.sourceforge.net
 PACKAGE_NAME = OpenVPN
-PACKAGE_STRING = OpenVPN 2.6.15
+PACKAGE_STRING = OpenVPN 2.6.19
 PACKAGE_TARNAME = openvpn
 PACKAGE_URL = 
-PACKAGE_VERSION = 2.6.15
+PACKAGE_VERSION = 2.6.19
 PATH_SEPARATOR = :
 PKCS11_HELPER_CFLAGS = 
-PKCS11_HELPER_LIBS = -lpthread -ldl -lcrypto -lpkcs11-helper
+PKCS11_HELPER_LIBS = 
 PKG_CONFIG = /usr/bin/pkg-config
 PKG_CONFIG_LIBDIR = 
 PKG_CONFIG_PATH = 
@@ -259,7 +260,7 @@
 SELINUX_LIBS = -lselinux
 SET_MAKE = 
 SHELL = /bin/bash
-SOCKETS_LIBS =  -lnsl -lresolv
+SOCKETS_LIBS =  -lresolv
 STRIP = strip
 SYSTEMD_ASK_PASSWORD = /usr/bin/systemd-ask-password
 SYSTEMD_UNIT_DIR = 
@@ -268,9 +269,9 @@
 TAP_WIN_MIN_MAJOR = 9
 TAP_WIN_MIN_MINOR = 9
 TEST_CFLAGS =     -I$(top_srcdir)/include 
-TEST_LDFLAGS =  -lssl -lcrypto   -lcmocka
+TEST_LDFLAGS =  -lssl -lcrypto    -lcmocka 
 TMPFILES_DIR = 
-VERSION = 2.6.15
+VERSION = 2.6.19
 WINDMC = no
 WOLFSSL_CFLAGS = 
 WOLFSSL_INCLUDEDIR = 
@@ -408,3 +409,4 @@
 	list='$(DISTFILES)'; \
 	  dist_files=`for file in $$list; do echo $$file; done | \
 	  sed -e "s|^$$srcdirstrip/||;t" \
+	      -e "s|^$$topsrcdirstrip/|$(top_builddir)/|;t"`; \

=== debian/changelog ===
openvpn (2.6.19-0ubuntu0.25.10.1) questing; urgency=medium

  * New upstream version 2.6.19 (LP: #2127658):
    - CVE Fixes:
      + CVE-2025-13086
    - Updates:
      + Disable DCO if --bind-dev option is given
    - Bug Fixes:
      + Fix incorrect file descriptor handling in p2mp server on inotify FD
        during a SIGUSR1 restart.
      + Fix bug where --management-forget-disconnect and --management-signal
        could be executed even if password authentication to managment
        interface was still pending.
      + Repair client-side interaction on reconnect between DCO event handling
        and --persist-tun.
      + Prevent crash on invalid server-ipv6 argument.
      + Fix invalid pointer creation in tls_pre_decrypt().
      + Properly check for errors in creation on $auth_failed_reason_file.
      + Apply close-on-exec option to correct socket for incoming TCP
        connections.
      + Fix missing perf_pop() call in ssl_mbedtls.
      + Apply more checks to incoming TLS handshake packets before creating new
        state.
      + Fix broadcast address configuration for broadcast-based applications
        using ifconfig to get address.
    - See https://community.openvpn.net/ReleaseHistory for additional
      information.
  * Remove patches fixed upstream:
    - d/p/CVE-2025-13086.patch
    [Fixed in 2.6.16]
    - d/p/avoid-redefining-ovpn-enums.patch
    - d/p/handle_intentional_route_push_float_ip.patch
    [Fixed in 2.6.15]
  * d/watch: Update download URL.

 -- Lena Voytek <lena.voytek@canonical.com>  Fri, 20 Feb 2026 18:02:57 -0500

openvpn (2.6.14-2ubuntu1.1) questing-security; urgency=medium

  * SECURITY UPDATE: incorrect HMAC verification check
    - debian/patches/CVE-2025-13086.patch: fix memcmp check for the hmac
      verification in the 3way handshake being inverted in
      src/openvpn/ssl_pkt.c, tests/unit_tests/openvpn/test_pkt.c.
    - CVE-2025-13086

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 24 Nov 2025 17:30:01 -0500

=== debian/watch ===
version=4
https://build.openvpn.net/downloads/releases/ \
(?:|.*/)openvpn(?:[_\-]v?|)(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## openvpn 2.7.0~alpha1

=== sample/sample-plugins/Makefile ===
--- 
+++ 
@@ -143,7 +143,7 @@
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
 ACLOCAL = ${SHELL} '/home/flichtenheld/openvpn/community/openvpn-build/src/openvpn/missing' aclocal-1.16
 AMTAR = $${TAR-tar}
-AM_DEFAULT_VERBOSITY = 1
+AM_DEFAULT_VERBOSITY = 0
 AR = ar
 AS = as
 AUTOCONF = ${SHELL} '/home/flichtenheld/openvpn/community/openvpn-build/src/openvpn/missing' autoconf
@@ -152,9 +152,9 @@
 AWK = gawk
 CC = gcc
 CCDEPMODE = depmode=gcc3
-CFLAGS = -Wall -Wno-stringop-truncation -g -O2 -std=c99 
+CFLAGS = -Wall -Wold-style-definition -Wstrict-prototypes -Wno-stringop-truncation -g -O2 -std=c11
 CMOCKA_CFLAGS = 
-CMOCKA_LIBS = -lcmocka 
+CMOCKA_LIBS = -lcmocka
 CPP = gcc -E
 CPPFLAGS = 
 CSCOPE = cscope
@@ -164,6 +164,7 @@
 DEPDIR = .deps
 DLLTOOL = false
 DL_LIBS = -ldl
+DNS_UPDOWN_TYPE = systemd
 DSYMUTIL = 
 DUMPBIN = 
 ECHO_C = 
@@ -174,7 +175,6 @@
 ETAGS = etags
 EXEEXT = 
 FGREP = /usr/bin/grep -F
-FILECMD = file
 GIT = git
 GREP = /usr/bin/grep
 IFCONFIG = /usr/sbin/ifconfig
@@ -187,13 +187,13 @@
 LD = /usr/bin/ld -m elf_x86_64
 LDFLAGS = 
 LIBCAPNG_CFLAGS = 
-LIBCAPNG_LIBS = -lcap-ng 
+LIBCAPNG_LIBS = -lcap-ng
 LIBNL_GENL_CFLAGS = 
 LIBNL_GENL_LIBS = 
 LIBOBJS = 
 LIBPAM_CFLAGS = 
 LIBPAM_LIBS = -lpam
-LIBS =  -lcap-ng 
+LIBS = 
 LIBTOOL = $(SHELL) $(top_builddir)/libtool
 LIPO = 
 LN_S = ln -s
@@ -201,8 +201,8 @@
 LT_SYS_LIBRARY_PATH = 
 LZ4_CFLAGS = 
 LZ4_LIBS = 
-LZO_CFLAGS = -I/usr/include/lzo 
-LZO_LIBS = -llzo2 
+LZO_CFLAGS = -I/usr/lzo/lzo
+LZO_LIBS = -llzo2
 MAKEINFO = ${SHELL} '/home/flichtenheld/openvpn/community/openvpn-build/src/openvpn/missing' makeinfo
 MANIFEST_TOOL = :
 MBEDTLS_CFLAGS = 
@@ -214,15 +214,19 @@
 OBJDUMP = objdump
 OBJEXT = o
 OPENSSL_CFLAGS = 
-OPENSSL_LIBS = -lssl -lcrypto 
+OPENSSL_LIBS = -lssl -lcrypto
 OPENVPN_VERSION_MAJOR = 2
-OPENVPN_VERSION_MINOR = 6
-OPENVPN_VERSION_PATCH = .19
+OPENVPN_VERSION_MINOR = 7
+OPENVPN_VERSION_PATCH = _alpha1
 OPTIONAL_CRYPTO_CFLAGS =  
-OPTIONAL_CRYPTO_LIBS =  -lssl -lcrypto 
+OPTIONAL_CRYPTO_LIBS =  -lssl -lcrypto
 OPTIONAL_DL_LIBS = -ldl
 OPTIONAL_INOTIFY_CFLAGS = 
 OPTIONAL_INOTIFY_LIBS = 
+OPTIONAL_LIBCAPNG_CFLAGS = 
+OPTIONAL_LIBCAPNG_LIBS = -lcap-ng
+OPTIONAL_LIBNL_GENL_CFLAGS = 
+OPTIONAL_LIBNL_GENL_LIBS = 
 OPTIONAL_LZ4_CFLAGS = 
 OPTIONAL_LZ4_LIBS = 
 OPTIONAL_LZO_CFLAGS = 
@@ -235,16 +239,17 @@
 OTOOL64 = 
 P11KIT_CFLAGS = 
 P11KIT_LIBS = 
+P11TOOL = 
 PACKAGE = openvpn
 PACKAGE_BUGREPORT = openvpn-users@lists.sourceforge.net
 PACKAGE_NAME = OpenVPN
-PACKAGE_STRING = OpenVPN 2.6.19
+PACKAGE_STRING = OpenVPN 2.7_alpha1
 PACKAGE_TARNAME = openvpn
 PACKAGE_URL = 
-PACKAGE_VERSION = 2.6.19
+PACKAGE_VERSION = 2.7_alpha1
 PATH_SEPARATOR = :
 PKCS11_HELPER_CFLAGS = 
-PKCS11_HELPER_LIBS = 
+PKCS11_HELPER_LIBS = -lpthread -ldl -lcrypto -lpkcs11-helper
 PKG_CONFIG = /usr/bin/pkg-config
 PKG_CONFIG_LIBDIR = 
 PKG_CONFIG_PATH = 
@@ -256,11 +261,14 @@
 ROUTE = /usr/sbin/route
 RST2HTML = rst2html
 RST2MAN = rst2man
+SCRIPTDIR = 
 SED = /usr/bin/sed
 SELINUX_LIBS = -lselinux
 SET_MAKE = 
 SHELL = /bin/bash
-SOCKETS_LIBS =  -lresolv
+SOCKETS_LIBS =  -lnsl -lresolv
+SOFTHSM2_MODULE = 
+SOFTHSM2_UTIL = 
 STRIP = strip
 SYSTEMD_ASK_PASSWORD = /usr/bin/systemd-ask-password
 SYSTEMD_UNIT_DIR = 
@@ -268,11 +276,10 @@
 TAP_WIN_COMPONENT_ID = tap0901
 TAP_WIN_MIN_MAJOR = 9
 TAP_WIN_MIN_MINOR = 9
-TEST_CFLAGS =     -I$(top_srcdir)/include 
-TEST_LDFLAGS =  -lssl -lcrypto    -lcmocka 
+TEST_CFLAGS =       -I$(top_srcdir)/include 
+TEST_LDFLAGS =  -lssl -lcrypto  -lcap-ng   -lcmocka
 TMPFILES_DIR = 
-VERSION = 2.6.19
-WINDMC = no
+VERSION = 2.7_alpha1
 WOLFSSL_CFLAGS = 
 WOLFSSL_INCLUDEDIR = 
 WOLFSSL_LIBS = 
@@ -283,7 +290,6 @@
 ac_ct_AR = ar
 ac_ct_CC = gcc
 ac_ct_DUMPBIN = 
-ac_ct_WINDMC = 
 am__include = include
 am__leading_dot = .
 am__quote = 
@@ -327,6 +333,7 @@
 runstatedir = ${localstatedir}/run
 sampledir = $(docdir)/sample
 sbindir = ${exec_prefix}/sbin
+scriptdir = ${pkglibexecdir}
 sharedstatedir = ${prefix}/com
 srcdir = .
 sysconfdir = ${prefix}/etc
@@ -404,9 +411,3 @@
 	$(MAKE) $(AM_MAKEFLAGS) distdir-am
 
 distdir-am: $(DISTFILES)
-	@srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
-	topsrcdirstrip=`echo "$(top_srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
-	list='$(DISTFILES)'; \
-	  dist_files=`for file in $$list; do echo $$file; done | \
-	  sed -e "s|^$$srcdirstrip/||;t" \
-	      -e "s|^$$topsrcdirstrip/|$(top_builddir)/|;t"`; \
